<?php
/*
 * --------------------------------------------------------------------------------
   شرکت پرداخت الکترونیک پاسارگاد - پپکو
 * --------------------------------------------------------------------------------
 * @subpackage	درگاه پرداخت پاسارگاد برای RSForm
 * @author    	شرکت پرداخت الکترونیک پاسارگاد
 * @link		https://pep.co.ir
 * @Copyright	تمامی حقوق مادی و معنوی برای شرکت پرداخت الکترونیک پاسارگاد محفوظ می باشد.
 * --------------------------------------------------------------------------------
*/

defined('_JEXEC') or die('Restricted access');

class plgSystemRSFPPasargad extends JPlugin
{
	protected $componentId 	= 500;
	protected $componentValue = 'pasargad';
	
	public function __construct( &$subject, $config )
	{
		parent::__construct( $subject, $config );
		$this->newComponents = array(500);
	}
	
	public function rsfp_bk_onAfterShowComponents()
	{
		$lang = JFactory::getLanguage();
		$lang->load( 'plg_system_rsfppasargad' );
		
		$mainframe 	= JFactory::getApplication();
		$db 		= JFactory::getDBO();
		$formId 	= JRequest::getInt('formId');
		
		$link = "displayTemplate('".$this->componentId."')";
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId))
			$link = "displayTemplate('".$this->componentId."', '".$components[0]."')";
		?>
		<li><a href="javascript: void(0);" onclick="<?php echo $link;?>;return false;" id="rsfpc<?php echo $this->componentId; ?>"><span id="pasargad"><?php echo JText::_('RSFP_PASARGAD_COMPONENT'); ?></span></a></li>
		<?php
	}

    public static function PepPayRequest($InvoiceNumber, $TerminalCode, $MerchantCode, $Amount, $RedirectAddress, $Mobile = '', $Email = '')
    {
        require_once(dirname(__FILE__) . '/includes/RSAProcessor.class.php');
        $processor = new RSAProcessor(dirname(__FILE__) . '/includes/certificate.xml', RSAKeyType::XMLFile);
        if (!function_exists('jdate')) {
            require_once(dirname(__FILE__) . '/includes/jdf.php');
        }
        $data = array(
            'InvoiceNumber' => $InvoiceNumber,
            'InvoiceDate' => jdate('Y/m/d'),
            'TerminalCode' => $TerminalCode,
            'MerchantCode' => $MerchantCode,
            'Amount' => $Amount,
            'RedirectAddress' => $RedirectAddress,
            'Timestamp' => date('Y/m/d H:i:s'),
            'Action' => 1003,
            'Mobile' => $Mobile,
            'Email' => $Email
        );

        $sign_data = json_encode($data);
        $sign_data = sha1($sign_data, true);
        $sign_data = $processor->sign($sign_data);
        $sign = base64_encode($sign_data);

        $curl = curl_init('https://pep.shaparak.ir/Api/v1/Payment/GetToken');
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Sign: ' . $sign
            )
        );
        $result = json_decode(curl_exec($curl));
        curl_close($curl);

        return $result;
    }

    public static function PepCheckTransactionResult($TransactionReferenceID, $InvoiceNumber='', $InvoiceDate='', $TerminalCode='', $MerchantCode='')
    {
        $data = array(
            'InvoiceNumber' => $InvoiceNumber,
            'InvoiceDate' => $InvoiceDate,
            'TerminalCode' => $TerminalCode,
            'MerchantCode' => $MerchantCode,
            'TransactionReferenceID' => $TransactionReferenceID
        );
        $curl = curl_init('https://pep.shaparak.ir/Api/v1/Payment/CheckTransactionResult');
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json'
            )
        );
        $result = json_decode(curl_exec($curl));
        curl_close($curl);

        return $result;
    }

    public static function PepVerifyRequest($InvoiceNumber, $InvoiceDate, $TerminalCode, $MerchantCode, $Amount)
    {
        require_once(dirname(__FILE__) . '/includes/RSAProcessor.class.php');
        $processor = new RSAProcessor(dirname(__FILE__) . '/includes/certificate.xml', RSAKeyType::XMLFile);
        $data = array(
            'InvoiceNumber' => $InvoiceNumber,
            'InvoiceDate' => $InvoiceDate,
            'TerminalCode' => $TerminalCode,
            'MerchantCode' => $MerchantCode,
            'Amount' => $Amount,
            'Timestamp' => date('Y/m/d H:i:s')
        );

        $sign_data = json_encode($data);
        $sign_data = sha1($sign_data, true);
        $sign_data = $processor->sign($sign_data);
        $sign = base64_encode($sign_data);

        $curl = curl_init('https://pep.shaparak.ir/Api/v1/Payment/VerifyPayment');
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Sign: ' . $sign
            )
        );
        $result = json_decode(curl_exec($curl));
        curl_close($curl);

        return $result;
    }

    public static function PepReversalRequest($InvoiceNumber, $InvoiceDate, $TerminalCode, $MerchantCode)
    {
        require_once(dirname(__FILE__) . '/includes/RSAProcessor.class.php');
        $processor = new RSAProcessor(dirname(__FILE__) . '/includes/certificate.xml', RSAKeyType::XMLFile);
        $data = array(
            'InvoiceNumber' => $InvoiceNumber,
            'InvoiceDate' => $InvoiceDate,
            'TerminalCode' => $TerminalCode,
            'MerchantCode' => $MerchantCode,
            'Timestamp' => date('Y/m/d H:i:s')
        );

        $sign_data = json_encode($data);
        $sign_data = sha1($sign_data, true);
        $sign_data = $processor->sign($sign_data);
        $sign = base64_encode($sign_data);

        $curl = curl_init('https://pep.shaparak.ir/Api/v1/Payment/RefundPayment');
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($data));
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Sign: ' . $sign
            )
        );
        $result = json_decode(curl_exec($curl));
        curl_close($curl);

        return $result;
    }
	public function rsfp_getPayment(&$items, $formId)
	{
		if ($components = RSFormProHelper::componentExists($formId, $this->componentId))
		{
			$data = RSFormProHelper::getComponentProperties($components[0]);
			
			$item 			= new stdClass();
			$item->value 	= $this->componentValue;
			$item->text 	= $data['LABEL'];
			
			// add to array
			$items[] = $item;
		}
	}
	
	public function rsfp_doPayment($payValue, $formId, $SubmissionId, $price, $products, $code)
	{
		$error_code = 'error_creating_order';
		$message = '';
		if ($payValue == $this->componentValue && $SubmissionId > 0 && $price > 0){
            $TerminalID	= RSFormProHelper::getConfig('pasargad.terminal_id');
            $MerchantID	= RSFormProHelper::getConfig('pasargad.merchant_id');
			$amount			= round($price, 2);
			$CallBackUrl	= JURI::root().'index.php?option=com_rsform&formId='.$formId.'&task=plugin&plugin_task=pasargad.notify&oid='.$SubmissionId.'&code='.$code;
            $Request = self::PepPayRequest($SubmissionId, $TerminalID, $MerchantID, $amount, $CallBackUrl);
            if(isset($Request) && $Request->IsSuccess) {
                self::d_redirect('https://pep.shaparak.ir/payment.aspx?n=' . $Request->Token);
            }
            else {
                $error_code = '';
                $message = isset($Request->Message) ? $Request->Message : 'خطای نامشخص';
            }
		}
        self::display_error($error_code, '', $SubmissionId, 0, $message);
	}
	public static function d_redirect($url='')
	{
		if($url != ''){
			if(headers_sent()){
				echo '<script type="text/javascript">window.location.assign("'.$url.'")</script>';
			}
			else{
				header("Location: $url");
			}
			exit();
		}
	}

    public static function display_error($pay_status = '', $tran_id = '', $order_id = '', $is_callback = 1, $message)
    {
        if ($pay_status == 'retry') {
            $page_title = 'خطای موقت در پرداخت';
            $admin_mess = 'در هنگام بازگشت خریدار از بانک سرور بانک پاسخ نداد ، از خریدار درخواست شد صفحه را رفرش کند';
            $retry_mess = '
				<div style="margin:15px 0px 21px 0px;font-size: 12px;">
					سرور درگاه اینترنتی <span style="color:#ff0000;">به صورت موقت</span> با مشکل مواجه شده است ، جهت تکمیل تراکنش لحظاتی بعد بر روی دکمه زیر کلیک کنید
				</div>
				<div style="margin:20px 0px 25px 0px;color:#008800;" id="reqreload">
					<button onclick="reload_page()">تلاش مجدد</button>
				</div>
				<script>
					function reload_page(){
						document.getElementById("reqreload").innerHTML = "در حال تلاش مجدد لطفا صبر کنید ..";
						location.reload();
					}
				</script>';
        } elseif ($pay_status == 'reversal_done') {
            $page_title = 'مشکل در ارائه خدمات';
            $admin_mess = 'خریدار مبلغ را پرداخت کرد اما در هنگام بازگشت از بانک مشکلی در ارائه خدمات رخ داد ، دستور بازگشت وجه به حساب خریدار در بانک ثبت شد';
            $client_mess = 'پرداخت شما با شماره پیگیری ' . $tran_id . ' با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />دستور بازگشت وجه به حساب شما در بانک ثبت شده است ، در صورتی که وجه پرداختی تا ساعات آینده به حساب شما بازگشت داده نشد با پشتیبانی تماس بگیرید (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
        } elseif ($pay_status == 'reversal_error') {
            $page_title = 'مشکل در ارائه خدمات';
            $admin_mess = 'خریدار مبلغ را پرداخت کرد اما در هنگام بازگشت از بانک مشکلی در ارائه خدمات رخ داد ، دستور بازگشت وجه به حساب خریدار در بانک ثبت شد اما متاسفانه با خطا روبرو شد ، به این خریدار باید یا خدمات ارائه شود یا وجه استرداد گردد';
            $client_mess = 'پرداخت شما با شماره پیگیری ' . $tran_id . ' با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />به منظور ثبت دستور بازگشت وجه به حساب شما در بانک اقدام شد اما متاسفانه با خطا روبرو شد ، لطفا به منظور دریافت خدمات و یا استرداد وجه پرداختی با پشتیبانی تماس بگیرید';
        } elseif ($pay_status == 'order_not_exist') {
            $page_title = 'سفارش یافت نشد';
            $admin_mess = 'سفارش در سایت یافت نشد';
            $client_mess = 'متاسفانه سفارش شما در سایت یافت نشد ! در صورتی که وجه پرداختی از حساب بانکی شما کسر شده باشد به صورت خودکار از سوی بانک به حساب شما باز خواهد گشت (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
        } elseif ($pay_status == 'invoice_id_is_blank') {
            $page_title = 'خطا در پارامتر ورودی';
            $admin_mess = 'پس از بازگشت از بانک شماره سفارش موجود نبود';
            $client_mess = 'متاسفانه پارامتر ورودی شما معتبر نیست ! در صورتی که وجه پرداختی از حساب بانکی شما کسر شده باشد به صورت خودکار از سوی بانک به حساب شما باز خواهد گشت (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
        } elseif ($pay_status == 'already_been_completed') {
            $page_title = 'سفارش پیش از این موفق شده است';
            $client_mess = 'سفارش شما پیش از این با شماره پیگیری ' . $tran_id . ' با موفقیت ثبت شده است';
        } elseif ($pay_status == 'order_not_for_this_person') {
            $page_title = $admin_mess = 'شماره سفارش نادرست است';
            $client_mess = 'شماره سفارش نادرست است ؛ در صورت نیاز به پشتیبانی تماس بگیرید';
        } elseif ($is_callback == '0') {
            $page_title = $admin_mess = 'خطا در ارسال به بانک';
            $client_mess = '<p style="text-align:center;">' . $message . '</p>';
        } else {
            $page_title = $admin_mess = 'پرداخت انجام نشد';
            $client_mess = 'خطا ؛ ';
            if($message != '') {
                $client_mess .= $message;
            }
            else {
                $client_mess .= 'در صورتی که وجه پرداختی از حساب بانکی شما کسر شده باشد به صورت خودکار از سوی بانک به حساب شما باز خواهد گشت (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد) - در صورت نیاز با پشتیبانی تماس بگیرید.';
            }
        }

        echo '
		<!DOCTYPE html> 
		<html xmlns="http://www.w3.org/1999/xhtml" lang="fa">
		<head>
		<title>' . $page_title . '</title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<style>body{font-family:tahoma;text-align:center;margin-top:30px;}</style>
		</head>
		<body>
			<div align="center" dir="rtl" style="font-family:tahoma;font-size:12px;border:1px dotted #c3c3c3; width:60%; margin: 50px auto 0px auto;line-height: 25px;padding-left: 12px;padding-top: 8px;">
				<span style="color:#ff0000;"><b>' . $page_title . '</b></span><br/>';
        if (isset($retry_mess)) {
            echo $retry_mess;
        } else {
            echo '<p style="text-align:right;margin-right:8px;">' . $client_mess . '</p><a href="' . JURI::root() . 'index.php">بازگشت >></a><br/><br/>';
        }
        echo '</div>
		</body>
		</html>
		';
        exit();
    }
	public function rsfp_bk_onAfterCreateComponentPreview($args = array())
	{
		if ($args['ComponentTypeName'] == 'pasargad')
		{
			$args['out'] = '<td>&nbsp;</td>';
			$args['out'].= '<td><img src="'.JURI::root(true).'/administrator/components/com_rsform/assets/images/icons/pasargad.png" /> '.$args['data']['LABEL'].'</td>';	
		}
	}
	
	public function rsfp_bk_onAfterShowConfigurationTabs($tabs)
	{
		$lang = JFactory::getLanguage();
		$lang->load( 'plg_system_rsfppasargad' );
		
		$tabs->addTitle(JText::_('RSFP_PASARGAD_LABEL'), 'form-pasargad');
		$tabs->addContent($this->pasargadConfigurationScreen());
	}
	
	public function rsfp_f_onSwitchTasks()
	{
		if (JRequest::getVar('plugin_task') == 'pasargad.notify')
		{
            $order_id = isset($_GET['oid']) ? $_GET['oid'] : '';
            $TransactionReferenceID = isset($_REQUEST['tref']) ? $_REQUEST['tref'] : '';
            $InvoiceNumber = isset($_REQUEST['iN']) ? $_REQUEST['iN'] : '';
            $InvoiceDate = isset($_REQUEST['iD']) ? $_REQUEST['iD'] : '';
            $TerminalID	= RSFormProHelper::getConfig('pasargad.terminal_id');
            $MerchantID	= RSFormProHelper::getConfig('pasargad.merchant_id');

            if ($order_id == $InvoiceNumber) {
                $db 	= JFactory::getDBO();
                $code 	= JRequest::getVar('code');
                $formId = JRequest::getInt('formId');
                $db->setQuery("SELECT SubmissionId FROM #__rsform_submissions s WHERE s.FormId='".$formId."' AND MD5(CONCAT(s.SubmissionId,s.DateSubmitted)) = '".$db->escape($code)."'");
                if($SubmissionId = $db->loadResult())
                {
                    if($SubmissionId == $InvoiceNumber){
                        if($TransactionReferenceID != '') {
                            $checkResult = self::PepCheckTransactionResult($TransactionReferenceID);
                        } else {
                            $checkResult = self::PepCheckTransactionResult(null, $InvoiceNumber, $InvoiceDate, $TerminalID, $MerchantID);
                        }

                        if(isset($checkResult) && $checkResult->IsSuccess) {
                            $amount = $checkResult->Amount;
                            $Request = self::PepVerifyRequest($InvoiceNumber, $InvoiceDate, $TerminalID, $MerchantID, $amount);
                            if (isset($Request) && $Request->IsSuccess && $checkResult->InvoiceNumber == $InvoiceNumber) {
                                $db->setQuery("UPDATE #__rsform_submission_values sv SET sv.FieldValue=1 WHERE sv.FieldName='_STATUS' AND sv.FormId='".$formId."' AND sv.SubmissionId = '".$SubmissionId."'");
                                if($db->execute()){
                                    $mainframe = JFactory::getApplication();
                                    $mainframe->triggerEvent('rsfp_afterConfirmPayment', array($SubmissionId));
                                    $back_link = JURI::root()."index.php?option=com_rsform&formId=$formId";
                                    echo '
								<!DOCTYPE html> 
								<html xmlns="http://www.w3.org/1999/xhtml" lang="fa">
								<head>
								<title>پرداخت تراکنش با موفقیت انجام شد</title>
								<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
								<style>body{font-family:tahoma;text-align:center;margin-top:30px;}</style>
								</head>
								<body>
									<div align="center" dir="rtl" style="font-family:tahoma;font-size:12px;border:1px dotted #c3c3c3; width:60%; margin: 50px auto 0px auto;line-height: 25px;padding-left: 12px;padding-top: 8px;">
										<span style="color:#008800;"><b>پرداخت شما با موفقیت انجام شد</b></span><br/>
										<p style="text-align:right;margin-right:8px;">شماره پیگیری پرداخت شما <strong>'.$TransactionReferenceID.'</strong> می باشد.</p><a href="'.$back_link.'">بازگشت >></a><br/><br/>
									</div>
								</body>
								</html>
								';
                                    exit();
                                }
                                else{
                                    $reversal_request = self::PepReversalRequest($InvoiceNumber, $InvoiceDate, $TerminalID, $MerchantID);
                                    if (isset($reversal_request) && $reversal_request->IsSuccess) {
                                        $message = 'پرداخت شما با شماره پیگیری ' . $TransactionReferenceID . ' با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />دستور بازگشت وجه به حساب شما در بانک ثبت شده است ، در صورتی که وجه پرداختی تا ساعات آینده به حساب شما بازگشت داده نشد با پشتیبانی تماس بگیرید (نهایت مدت زمان بازگشت به حساب 72 ساعت می باشد)';
                                    } else {
                                        $message = 'پرداخت شما با شماره پیگیری ' . $TransactionReferenceID . ' با موفقیت در بانک انجام شده است اما در ارائه خدمات مشکلی رخ داده است !<br />به منظور ثبت دستور بازگشت وجه به حساب شما در بانک اقدام شد اما متاسفانه با خطا روبرو شد ، لطفا به منظور دریافت خدمات و یا استرداد وجه پرداختی با پشتیبانی تماس بگیرید';
                                    }
                                }
                            }
                            else {
                                $message = $Request->Message;
                            }
                        }
                        else {
                            $message = 'پرداخت توسط شما انجام نشده است ، در صورت نیاز با پشتیبانی تماس بگیرید.';
                        }
                    }
                    else{
                        $error_code = 'order_not_for_this_person';
                    }
                }
                else{
                    $error_code = 'order_not_exist';
                }
            }
            else {
                $error_code = 'order_not_for_this_person';
            }
            self::display_error(isset($error_code) ? $error_code : null, $TransactionReferenceID, $order_id, 1, isset($message) ? $message : '');
		}
	}
	
	public function pasargadConfigurationScreen()
	{
		ob_start();
		
		?>
		<div id="page-pasargad" class="com-rsform-css-fix">
			<table  class="admintable">
				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label for="currency"><?php echo JText::_( 'RSFP_PASARGAD_TERMINAL_ID' ); ?></label></td>
					<td><input type="text" name="rsformConfig[pasargad.terminal_id]" value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('pasargad.terminal_id')); ?>" size="100" maxlength="64"></td>
				</tr>
				<tr>
					<td width="200" style="width: 200px;" align="right" class="key"><label for="currency"><?php echo JText::_( 'RSFP_PASARGAD_MERCHANT_ID' ); ?></label></td>
					<td><input type="text" name="rsformConfig[pasargad.merchant_id]" value="<?php echo RSFormProHelper::htmlEscape(RSFormProHelper::getConfig('pasargad.merchant_id')); ?>" size="100" maxlength="64"></td>
				</tr>
			</table>
		</div>
		<?php
		
		$contents = ob_get_contents();
		ob_end_clean();
		return $contents;
	}
}

class RSFormProPasargad
{
	public $args = array();
	public $url;
	
	public static function getInstance() {
		static $inst;
		if (!$inst) {
			$inst = new RSFormProPasargad;
		}
		
		return $inst;
	}
}