<?php
/*
 * --------------------------------------------------------------------------------
   شرکت پرداخت الکترونیک پاسارگاد - پپکو
 * --------------------------------------------------------------------------------
 * @subpackage	درگاه پرداخت پاسارگاد برای RSForm
 * @author    	شرکت پرداخت الکترونیک پاسارگاد
 * @link		https://pep.co.ir
 * @Copyright	تمامی حقوق مادی و معنوی برای شرکت پرداخت الکترونیک پاسارگاد محفوظ می باشد.
 * --------------------------------------------------------------------------------
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

class plgSystemRSFPPasargadInstallerScript
{
	public function preflight($type, $parent) {
		if ($type != 'uninstall') {
			$app = JFactory::getApplication();
			
			if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/rsform.php')) {
				$app->enqueueMessage('Please install the RSForm! Pro component before continuing.', 'error');
				return false;
			}
			
			if (!file_exists(JPATH_ADMINISTRATOR.'/components/com_rsform/helpers/version.php')) {
				$app->enqueueMessage('Please upgrade RSForm! Pro to at least R45 before continuing!', 'error');
				return false;
			}
			
			if (!file_exists(JPATH_PLUGINS.'/system/rsfppayment/rsfppayment.php')) {
				$app->enqueueMessage('Please install the RSForm! Pro Payment Plugin first!', 'error');
				return false;
			}
			
			$jversion = new JVersion();
			if (!$jversion->isCompatible('2.5.5')) {
				$app->enqueueMessage('Please upgrade to at least Joomla! 2.5.5 before continuing!', 'error');
				return false;
			}
		}
		
		return true;
	}
	
	public function postflight($type, $parent) {
		if ($type == 'update') {
			$db = JFactory::getDbo();
			$db->setQuery("SELECT * FROM #__rsform_config WHERE `SettingName`='pasargad.return'");
			if (!$db->loadResult()) {
				$db->setQuery("INSERT IGNORE INTO `#__rsform_config` (`SettingName`, `SettingValue`) VALUES ('pasargad.return', '')");
				$db->execute();
			}
		}
	}
}